-- REGIST 车险报案

业务对象命名：
REGIST
REGIST_ACTUALDATA
REGIST_ACTUALDATA_PRPLCREGIST
REGIST_ACTUALDATA_PRPLCREGIST_PRPLREPORTER
REGIST_ACTUALDATA_PRPLCREGIST_PRPLLINKER
REGIST_ACTUALDATA_PRPLPOLICY
REGIST_ACTUALDATA_PRPLCARLOSSDETAIL
REGIST_ACTUALDATA_PRPLCARLOSSDETAIL_PRPLCAR
REGIST_ACTUALDATA_PRPLCDAMAGE
REGIST_ACTUALDATA_PRPLCDAMAGE_PRPLDAMAGEADDRESS

{
    actualData row(
        accidentNo          String , -- 事故号
        damageStartDate     String , -- 出险时间 无需转码 2021-06-27 19:25:00
        reportDate          String , -- 报案时间 无需转码 2021-06-27 19:37:18
        damageAddress       String , -- 出险地点
        prplcregist array<row(
            policyNo        String , -- 保单号
            registNo        String , -- 报案号
            deptCode        String , -- 理赔机构代码
            deptName        String , -- 理赔机构名称
            prplreporter row(
                reporterName            String , -- 报案人名称
                reporterMobileNo        String   -- 报案人电话
            ) ,
            prpllinker row(
                linkerName          String , -- 联系人名称
                linkerPhoneNo       String   -- 联系人电话
            )
        )> ,
        prplpolicy array<row(
            comCode         String , -- 承保机构代码
            comName         String , -- 承保机构名称
            riskCode        String , -- 险种代码
            riskName        String , -- 险种名称
            licenseNo       String , -- 车牌号
            isSelected      String   -- 是否选择
        )> ,
        prplcarlossdetail array<row(
            prplcar row(
                brandCode           String , -- 品牌
                carModelCode        String   -- 车型
            ) ,
            indemnityDutyRate       车赔付比例
        )> ,
        prplcdamage row(
            prpldamageaddress row(
                longitude     String , -- 经度
                latitude      String   -- 纬度
            ) ,
            damageName      String , -- 出险原因
            damageCourse    String   -- 出险经过
        ) ,
        prplccheck row(
            checkDate       查勘日期
        ) ,
        prplclaim row(
            claimDate   出险时间
            sumclaim    估损金额
        ) ,
        prplccompensate array<row(
            compensateVericDate     核赔日期
            sumThisPaid             总赔付金额
            sumDutyPaid             直接理赔费用总金额原币金额
        )> ,
        prplendcase array<row(
            closeCaseDate   结案时间
        )> ,
        prplcrecase array<row(
            recaseDate      案件重开时间
        )> ,
        prplcertify row(
            completeDate    资料接收齐全时间
        ) ,
        prplproplossdetail array<row(  -- miss
            prplproploss  array<row(   -- miss
                paidRate    财赔付比例
            )>
        )> ,
        prplpersondetail array<row( -- miss
            prplperson array<row(   -- miss
                originPaidRate  人赔付比例
            )>
        )>
    ),
    log_time   String         ,

    nodeCode   String

}